;Wakeup-Timer, Version 1.01 von St. Epstein (mit auto_on und upgepulltem PD2 als Eingang)
;vom 13.05.2004
;Die Subroutinen, v.a. die fr die Umrechnung der Strings stammen aus dem WWW,
;genaue Quellen kann ich nicht mehr angeben.
;Das hier ist der Assembler-Code, bei nderungen hier mu neu assembliert werden.
;Bei Verwendung eines anderen Controllers mu der entsprechende *.inc File genommen werden!!! Beigefgt ist nur der vom 2313
;In den Controller wird der *.Hex-File geladen!
;fr eine bessere Dokumentation hatte ich leider immer noch keine Zeit

.include	"C:\avrtools\appnotes\2313DEF.INC"		;den Pfad zum *.inc File bitte anpassen
;
.DSEG
waits:		.Byte	 2
co:			.Byte	 9
num:		.Byte	 6
s:			.Byte	 1
tmp:		.Byte	 1
		
_SysPar:	.Byte	1

.CSEG
.ORG	0
		rjmp	_Reset
.ORG		INT0addr
		reti
.ORG		INT1addr
		reti
.ORG		ICP1addr
		reti
.ORG		OC1addr 
		reti
.ORG		OVF1addr
		rjmp	IntN5

_Reset:
		ldi		yl,Low(RAMEND)
		out		SPL,yl
		sbiw	yl,32
		ldi		zl,0x18
		out		UCR,zl
		ldi		zl,0
		sts		_SysPar,zl

		ldi		zh,high(25)
		ldi		zl,Low(25)
		out		UBRR,zl


;Initialisierung:

;-> Power
		cbi		DDRB,4
;-> Sensorpin
		cbi		DDRD,2

;-> LED
		sbi		DDRB,3
		cbi		PORTB,4
		sbi		PORTB,3
;-> Sensorpin
		sbi		PORTD,2

		ldi		zl,Low(11)
		out		tcnt1h,zl

		ldi		zl,Low(220)
		out		tcnt1l,zl

;-> statusflag
		set
		bld		r3,0

		sei

		in		zl,TIMSK
		sbr		zl,0x80
		out		TIMSK,zl

		in		zl,TCCR1B
		sbr		zl,3
		out		TCCR1B,zl

		ldi		zl,Low(5)
		rcall	_ws

		rcall	_PWon

		sbi		PORTB,3



;Hauptprogramm
init:

		ldi		zl,Low(0)
		ldi		zh,high(0)
		sts		waits,zl
		sts		waits+1,zh
		ldi		zl,Low(60)
		sts		s,zl
		clt
		bld		r3,0

		ldi		zl,Low(0)
		rcall	_B2Str
		ldi		r23,9
		ldi		xl,Low(co)
		rcall	_StStr
		ldi		zl,Low(0)
		rcall	_B2Str
		ldi		r23,6
		rcall	_StStr
		ldi		zl,Low(0)
		sts		tmp,zl

main:

;Inputroutine
		ldi		r25,8
		ldi		xl,Low(co)
		ldi		xh,high(co)
		rcall	_InStr

;Stringvergleich
		ldi		zl,Low(co)
		mov		r24,zl
		ldi		zl,Low(3)
		mov		r23,zl
		inc		r23
		mov		zl,r24
		ldi		xl,Low(num)
		rcall	_StStr

		ldi		zl,Low(num)
		mov		xl,zl
		mov		xh,zh
		ldi		zl,Low(S00*2)
		ldi		zh,high(S00*2)
		rcall	_StCCp
		breq	PC+0x02
		rjmp	L0001
L0002:

		rjmp		delays

		rjmp	L0000
L0001:
		ldi		zl,Low(num)
		mov		xl,zl
		mov		xh,zh
		ldi		zl,Low(S01*2)
		ldi		zh,high(S01*2)
		rcall	_StCCp
		breq	PC+0x02
		rjmp	L0003
L0004:

		sbi		PORTB,3

		rjmp		init

		rjmp	L0000
L0003:

		rjmp		main

L0000:

;bernahme Anzahl Minuten
delays:

		ldi		zl,Low(co)
		rcall	_LenS
		push	zl
		ldi		zl,Low(3)
		pop		r24
		Sub		r24,zl
		mov		zl,r24
		sts		tmp,zl

		lds		r24,tmp
		ldi		zl,Low(0)
		cp		r24,zl
		breq	PC+0x02
		rjmp	L0006
L0007:

		rjmp		init

L0006:
L0005:

		ldi		zl,Low(co)
		mov		r24,zl
		rcall	_LenS
		add		r24,zl
		lds		zl,tmp
		Sub		r24,zl
		mov		r23,zl
		inc		r23
		mov		zl,r24
		ldi		xl,Low(num)
		rcall	_StStr

		ldi		zl,Low(num)
		mov		xl,zl
		rcall	_St2Nm
		sts		waits,zl
		sts		waits+1,zh

		lds		r24,waits
		lds		r25,waits+1
		ldi		zl,Low(0)
		ldi		zh,high(0)
		cp		r24,zl
		cpc		r25,zh
		breq	PC+0x02
		rjmp	L0009
L0010:

		rjmp		init

L0009:
L0008:

		Set
		bld		r3,0

		ldi		zl,Low(60)
		sts		s,zl

		rjmp		main


;Interruptroutine
IntN5:
		in		r2,SREG
		push	zl
		push	zh
		push	r0
		push	r1
		push	r24
		push	r25
		push	xl
		push	xh
		push	r20
		push	r21
		push	r22
		push	r23
;Hier wird der Timer gesetzt. Die Werte aus AvrCalc einfach in Dezimalzahlen umrechnen und entsprechend ersetzen.
;Die vorgegebenen Werte sind fr 4 MHz berechnet!
;Hier TCNT1H
		ldi		zl,Low(11)
		out		tcnt1h,zl

;Hier TCNT1L
		ldi		zl,Low(220)
		out		tcnt1l,zl

		sbrc	r3,0
		rjmp	L0012
L0013:

		rjmp		endi
;Zhlroutine
L0012:
L0011:

		lds		zl,s
		dec		zl
		sts		s,zl

		lds		r24,s
		ldi		zl,Low(0)
		inc		zl
		cp		r24,zl
		brsh	PC+0x02
		rjmp	L0015
L0016:

		rjmp		led

L0015:
L0014:

		lds		zl,waits
		lds		zh,waits+1
		sbiw	zl,1
		sts		waits,zl
		sts		waits+1,zh

		lds		r24,waits
		lds		r25,waits+1
		ldi		zl,Low(0)
		ldi		zh,high(0)
		adiw	zl,1
		cp		r24,zl
		cpc		r25,zh
		brsh	PC+0x02
		rjmp	L0018
L0019:

		ldi		zl,Low(60)
		sts		s,zl

		rjmp		led
;Hier wird der Rechner eingeschaltet
L0018:
L0017:

		cli

		sbi		PORTB,3
		rcall	_PWon
		clt
		bld		r3,0
		ldi		zl,Low(60)
		sts		s,zl

		sei

		rjmp		endi

led:

		in		zl,PORTB
		ldi		r23,0x08
		eor		zl,r23
		out		PORTB,zl

endi:

		pop		r23
		pop		r22
		pop		r21
		pop		r20
		pop		xh
		pop		xl
		pop		r25
		pop		r24
		pop		r1
		pop		r0
		pop		zh
		pop		zl
		out		SREG,r2
		reti

;Jetzt kommen diverse Unterprogramme

;das sind die Kommandokonstanten
S00:	.db	"WKM", 0
S01:	.db	"CLT", 0


;Speicherung der Stringeingaben
_StStr:	tst		r23
		breq	_Str4
_Str3:	ld		r24,Z+
		tst		r24
		breq	_Str2
		dec		r23
		breq	_Str1
		st		X+,r24
		rjmp	_Str3
_Str1:	clr		r24
_Str2:	st		X+,r24
		sbiw	xl,1
_Str4:	ret

_GetCh:	
;-> Sensorpinabfrage
	sbic		PIND,2
	rjmp	_GetCh1
	cli
	rcall	_PWon
	sei
	rjmp	init
_GetCh1:
	sbis		USR,0x07
	rjmp	_GetCh
	in		zl,UDR
	ret

;Vergleichsroutine
_StCCp:	push	xl
		push	xh
_StCC2:	ld		r24,X+
		lpm
		adiw	zl,1
		cp		r24,r0
		brne	_StCC1
		tst		r24
		brne	_StCC2
_StCC1:	pop		xh
		pop		xl
		ret

;Berechnung der Stringlnge
_LenS:	clr		r22
_LenS1:	ld		r23,Z+
		tst		r23
		breq	_LenS2
		inc		r22
		rjmp	_LenS1
_LenS2:	mov		zl,r22
		ret

;Stringeingabe1
_Input:	ldi		xl,Low(RAMEND - 32)
		ldi		r25,6
_InStr:	rcall	_GetCh
		cpi		zl,10
		breq	_InStr
		cpi		zl,13
		breq	_InEnd
		cpi		zl,8
		breq	_InBck
		tst		r25
		breq	_InStr
		st		X+,zl
		dec		r25
		rjmp	_InStr
_InEnd:	clr		zl
		st		X,zl
		ret
_InBck:	inc		r25
		sbiw	xl,1
		rjmp	_InStr

;Stringumrechnung
_StrNm:	ldi		xl,Low(RAMEND - 32)
_St2Nm:	clt
		clr		r19
		clr		r20
		ldi		r24,10
		clr		r25
_StrN1:	ld		zl,X+
		tst		zl
		breq	_StrSg
		cpi		zl,0x09
		breq	_StrN1
		cpi		zl,0x2d
		brne	_StrS
		Set
		rjmp	_StrN1
_StrS:	subi	zl,0x30
		push	zl
		mov		zl,r19
		mov		zh,r20
		rcall	Mp16u
		pop		r22
		add		zl,r22
		Adc		zh,r25
		mov		r19,zl
		mov		r20,zh
		rjmp	_StrN1
_StrSg:	mov		zl,r19
		mov		zh,r20
		brtc	_StrEx
		Com		zl
		Com		zh
		adiw	zl,1
_StrEx:	ret

;Stringumrechnung1
_B2str:	clr		zh
		clt
		push	yl
		st		-Y,zh
_N2str:	ldi		xl,0x08
		Sub		xh,xh
_N2st1:	lsr		zh
		rol		zl
		rol		xh
		rol		zh
		cpi		xh,0x0a
		brcs	_N2st2
		sbci	xh,0x0a
		inc		zl
_N2st2:	dec		xl
		brne	_N2st1
		subi	xh,-0x30
		st		-Y,xh
		tst		zl
		brne	_N2str
_N2st3:	mov		zl,yl
		pop		yl
		ret

;Warteschleifen
_Wms:	ldi		r20,0x14
_Wms1:	ldi		r21,0x42
_Wms2:	dec		r21
		brne	_Wms2
		dec		r20
		brne	_Wms1
		dec		zl
		brne	_Wms
		ret

_Ws:	mov		zh,zl
_Ws3:	ldi		r22,0x04
_Ws1:	ldi		zl,0xfa
		rcall	_Wms
		dec		r22
		brne	_Ws1
		dec		zh
		brne	_Ws3
		ret


;Multiplikation
Mp16u:	clr		r23
		clr		r22
		ldi		r21,0x10
		lsr		zh
		ror		zl
m16u1:	brcc	m16u2
		add		r22,r24
		Adc		r23,r25
m16u2:	ror		r23
		ror		r22
		ror		zh
		ror		zl
		dec		r21
		brne	m16u1
		ret

_PWon:
		sbi		DDRB,4

		ldi		zl,Low(500)
		ldi		zh,high(500)
		rcall	_wms

		cbi		DDRB,4
		ret
